const Gio = imports.gi.Gio;
const St = imports.gi.St;
const Main = imports.ui.main;
const Layout = imports.ui.layout;
const Overview = imports.ui.overview;
const overviewControls = imports.ui.overviewControls;
const Lang = imports.lang;
const Shell = imports.gi.Shell;
const panel = imports.ui.panel;
const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
const expose_iconPath = Me.path + '/img/windowslist.svg';
let expose_button, rb_index;
function init() {
    init_expose();
}

function enable() {
    enable_expose();
}

function disable() {
    disable_expose();

}

function init_expose() {

    expose_button = new St.Bin({ style_class: 'panel-button',
                          reactive: true,
                          can_focus: true,
                          x_fill: true,
                          y_fill: true,
                          track_hover: true }); 
    let expose_icon = new St.Icon({ 
                          gicon: Gio.icon_new_for_string(expose_iconPath),
                          style_class: 'system-status-icon expose-icon'});
    expose_button.set_child(expose_icon);
    expose_button.connect('button-press-event', function(){ 
      if (!Main.overview.visible) {
        Main.overview.toggle();
      } else { 
        if (Main.overview.viewSelector._showAppsButton.checked) {
            Main.overview.viewSelector._showAppsButton.checked = false;
        } else {
              Main.overview.toggle();
        } 
      }
    }); 
}

function enable_expose() {
{    rb_index = Main.panel._rightBox.get_children();
    Main.panel._rightBox.insert_child_at_index(expose_button, rb_index.length +1);
}{
    let indicator = Main.panel.statusArea['activities'];
    if(indicator != null) {
        indicator.container.hide();
    }
  }
}

function disable_expose() { 
	Main.panel._rightBox.remove_child(expose_button);
    {
	let indicator = Main.panel.statusArea['activities'];
    if(indicator != null) {
        indicator.container.show();
    }
  }
}
